<script lang="ts" setup>
import { useMemberStore } from '@/stores/member'
import { ref } from 'vue'
import MemberPointCard from './MemberPointCard.vue'
import { useReceiptStore } from '@/stores/receipt'

const memberStore = useMemberStore()
const receiptStore = useReceiptStore()
function onClick() {
  console.log('clicked')
  memberStore.searchMember(memberStore.tel)
  if (memberStore.currentMember !== null) {
    receiptStore.receipt.member = memberStore.currentMember
    console.log('Member is setted')
  } else {
    console.log('There is no Member on this receipt')
  }
}

const getAlertColor = (type: any) => {
  switch (type) {
    case 'success':
      return '#4CAF50' // Green color for success
    case 'error':
      return '#cc3300' // Red color for error
    // Add more cases for other alert types if needed
    default:
      return '#ffcc00' // Default color
  }
}
</script>
<template>
  <v-btn prepend-icon="mdi-magnify" elevation="10" @click="memberStore.useMemberDialog = true" block
    >findMember
  </v-btn>
  <!-- start of Mempointdialog -->
  <v-dialog v-model="memberStore.useMemberDialog" persistent min-width="500" max-width="700">
    <v-card color="white">
      <v-card-title>
        <v-container>
          <v-row style="color: rgb(247, 156, 82); font-weight: bold"> Member Point </v-row>
        </v-container>
      </v-card-title>

      <v-card-text>
        <!-- put search bar here and make Memberfound here -->
        <v-col class="pe-4">
          <!-- member point card -->
          <member-point-card></member-point-card>

          <v-row class="pt-10">
            <v-responsive class="mx-auto" max-width="344">
              <v-text-field
                type="input"
                v-model="memberStore.tel"
                density="compact"
                outlined
                clearable
                prepend-inner-icon="mdi-magnify"
                label="Member's phone number"
                hint="Search member by Tel"
                @click:prepend-inner="onClick"
                @keyup.enter="onClick"
              ></v-text-field>
              <v-row>
                <!-- Use point Here -->
                <v-col>
                  <v-btn
                    color="white"
                    style="font-weight: bold"
                    variant="elevated"
                    block
                    class="textcenter"
                    size="large"
                    elevation="10"
                    @click="memberStore.usePoint()"
                  >
                    USE POINT
                  </v-btn>

                  <!-- Lower line is for checking -->
                  <!-- <v-btn color="white" variant="elevated" block class="textcenter" size="large"
                    @click=" memberStore.logCheckCurrentMember()">Log check</v-btn> -->
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12">
                  <v-alert
                    v-model="memberStore.alert"
                    :value="memberStore.alert"
                    :type="memberStore.alertType"
                    dismissible
                    class="text-body-2"
                    :color="getAlertColor(memberStore.alertType)"
                    density="compact"
                  >
                    {{ memberStore.alertMessage }}
                  </v-alert>
                </v-col>
              </v-row>
            </v-responsive>
          </v-row>

          <v-row class="pt-10">
            <v-sheet
              class="mx-auto mt-5"
              rounded="lg"
              elevation="12"
              width="600"
              color="rgba(247, 156, 82)"
            >
              <v-container>
                <!-- Your content goes here -->
                <v-row>
                  <v-col cols="4" class="pe-4" lg="4" md="12" style="color: white">
                    Name:
                    {{
                      memberStore.currentMember ? memberStore.currentMember?.name : '"not found"'
                    }}</v-col
                  >
                  <v-col cols="4" class="pe-4" lg="4" md="12" style="color: white"
                    >Member's Id:
                    {{ memberStore.currentMember ? memberStore.currentMember?.id : '-' }}</v-col
                  >
                  <v-col cols="4" class="pe-10" lg="4" md="12" style="color: white"
                    >Point:
                    {{ memberStore.currentMember ? memberStore.currentMember?.point : '-' }}</v-col
                  >
                </v-row>
              </v-container>
            </v-sheet>
          </v-row>
        </v-col>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="white"
          variant="elevated"
          @click="
            (memberStore.useMemberDialog = false), memberStore.clear(), memberStore.clearTextField()
          "
        >
          cancel
        </v-btn>
        <v-btn
          color="white"
          variant="elevated"
          class="ma-2"
          @click="memberStore.dialogConfirm = true"
        >
          Confirm
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="memberStore.dialogConfirm" persistent width="auto">
    <v-card color="rgba(114, 87, 42, 1)">
      <v-card-title> Confirm? </v-card-title>
      <v-card-text> Do you want to proceed? </v-card-text>
      <v-card-actions>
        <!-- put the space to make the button to the foot of dialog -->
        <v-spacer></v-spacer>
        <v-btn
          @click="(memberStore.dialogConfirm = false), (memberStore.useMemberDialog = false)"
          append-icon="mdi-cancel"
        >
          Cancel
        </v-btn>
        <v-btn
          @click="(memberStore.dialogConfirm = false), (memberStore.useMemberDialog = false)"
          append-icon="mdi-check-circle"
        >
          Yes
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
